require 'httparty'


module Corraios
  SERVICES = {
    pac: 41106,
    sedex: 40010,
    e_sedex: 81019,
    sedex_10: 40215
  }

  def self.code_for(service)
    SERVICES[service]
  end

  class CorraiosError < StandardError; end
  class InvalidMeasures < CorraiosError; end
  class UnknownMeasures < CorraiosError; end
  class ServiceUnreachable < CorraiosError; end
  class InvalidResponse < CorraiosError; end
end


require 'corraios/containers/base'
require 'corraios/containers/envelope'
require 'corraios/containers/package'
require 'corraios/containers/roll'
require 'corraios/calculator'
require 'corraios/delivery'
require 'corraios/packer'
require 'corraios/version'
