module Corraios

  module Containers

    class Envelope < Base
      set_format 3
      add_attribute :weight, 0.0..1, 'nVlPeso'
      add_attribute :width, 11..60, 'nVlLargura'
      add_attribute :length, 16..60, 'nVlComprimento'

      def can_merge?(envelope)
        new_weight = self.weight + envelope.weight

        self.class.valid_field? :weight, new_weight
      end

      def merge!(other)
        self.weight += other.weight
        #TODO: usar maiores
      end

      def to_package
        Package.new(weight: self.weight,
          height: 2,
          width: Package::floor_for(:width, self.width),
          length: Package::floor_for(:length, self.length)
        )
      end
    end
  end
end