module Corraios

  module Containers

    class Roll < Base
      set_format 2
      add_attribute :weight, 0..30, 'nVlPeso'
      add_attribute :length, 18..105, 'nVlComprimento'
      add_attribute :diameter, 5..91, 'nVlDiametro'

      def can_merge?(other)
        false
      end

      def merge!(other)
        raise NotImplementedError
      end

      def volume
        3.1415 * (diameter/2)**2 * length
      end

      def to_package
        Package.new(
          weight: self.weight,
          height: Package::floor_for(:height, self.diameter),
          width: Package::floor_for(:width, self.diameter),
          length: Package::floor_for(:length, self.length)
        )
      end

      class << self

        def valid_fields?(attributes)
          super(attributes) &&
            (attributes[:diameter] * 2 + attributes[:length]) <= 200.0
        end
      end
    end
  end
end